      program main
c.... subroutine main.

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  main.    Updated     2004 January 27 14:00.
c               main.    Originated  1992 July 31 14:30.
c
c     Author:   Arthur L. Edwards.
c
c     Purpose:  To test apt subroutines on the GPS network.
c
c     Logic:    Entry points:  main.
c               Called by:  none.
c               Calls:  ???
c
c     Glossary:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

c===============================================================================

c.... Parameters and variables needed for use of aptffip.

c---- Max # of characters in an ASCII string.
      parameter (iamax = 80)
c---- Max # of digits in an integer machine word.
      parameter (idmax  = 18)
c---- Max + or - exponent in a floating-point machine word.
      parameter (iemax  = 308)
      parameter (pi     = 3.14159265358979323)

      common /ltest/ aword(40)        ! User message fields.  ASCII (1).
      character*80 aword              ! User message fields.  ASCII (1).
      common /ltest/ iword(40)        ! User message fields.  Integer (2).
      common /ltest/ fword(40)        ! User message fields.  Real (3).
      common /ltest/ lword(40)        ! Input line field lengths.
      common /ltest/ mtype(40)        ! Input line field types.
      common /ltest/ nword            ! # of input line fields.
      common /ltest/ achar(80)        ! User message uncracked ASCII words.
      character*1 achar               ! User message uncracked ASCII words.
      common /ltest/ nerr             ! Error return from aptffip.
      common /ltest/ fd               ! Field delimiter.
      character*1 fd                  ! Field delimiter.
      common /ltest/ aseven           ! Fills up rest of word.
      character*7 aseven              ! Fills up rest of word.

c=======================================================================********

c.... Local variables

      common /ltest/ ablank80         ! Long blank word.
      character*80 ablank80           ! Long blank word.
      common /ltest/ aend80           ! Long word "end".
      character*80 aend80             ! Long word "end".
      common /ltest/ ainput           ! Name of input file.
      character*80 ainput             ! Name of input file.
      common /ltest/ aoutput          ! Name of output file.
      character*80 aoutput            ! Name of output file.
      common /ltest/ atype            ! File type.
      character*8 atype               ! File type.
      common /ltest/ aversion         ! Name of code version.
      character*16 aversion           ! Name of code version.
      common /ltest/ lodmach          ! Machine letter of code load.
      character*8 lodmach             ! Machine letter of code load.
      common /ltest/ loddate          ! Date of code load.
      character*16 loddate            ! Date of code load.
      common /ltest/ lodtime          ! Time of code load.
      character*8 lodtime             ! Time of code load.
      common /ltest/ adate            ! Run date.
      character*8 adate
      common /ltest/ atime            ! Run time.
      character*8 atime
      common /ltest/ amach            ! Run machine.
      character*8 amach
      common /ltest/ ans              ! User's answer.
      character*8 ans                 ! User's answer.

c===============================================================================

c.... TEST SECTION VARIABLES.

      character*80 astem
      character*80 asubs
      character*80 asrce

c.... END OF TEST SECTION VARIABLES.

c=======================================================================********

c.... Initialize.

      ablank80 = ' '                  ! A long blank word.
      aend80   = 'end'                ! Long word "end".
      fd       = ' '                  ! Field delimiter.

c=======================================================================********

c.... Name code version.

      aversion = 'test EAST 1.0'

c.... Find load time, date, machine, and write out.

      loddate = '2003-09-12'
      lodtime = '12:00'
      lodmach = 'DEC-gps'

 8100 format ('  Version ',a16,' loaded on ',a16,' at ',a8,
     &  ' on ',a8)

      write (6, 8100) aversion, loddate, lodtime, lodmach

c=======================================================================********

c.... Find run date and time.

cuni      call date  (adate)
      atime = ' '
cuni      call clock (atime)
      adate = ' '
      amach = lodmach

c=======================================================================********

c.... Get execution line symbols aword(n), n = 1, nword.

      nword = iargc ()
      call getarg (1, aword(1))
      call getarg (2, aword(2))

 8110 format ('  Usage is:  test infile outfile')
 8112 format ('  (outfile may by tty for user''s terminal).')
 8114 format ('  Type names of input and output files or "end".')

  102 if (aword(1) .eq. 'help    ') then
        write (   6, 8110)
        write (   6, 8112)
        write (   6, 8114)
        call aptffip (5, fd, iamax, idmax, iemax, aword, iword, fword,
     &                mtype, lword, nword, achar, nerr)
        go to 105
      endif

  105 if ((nerr .ne. 0) .or.
     &    (nword .lt. 1) .or.
     &    (nword .gt. 2)) then
        write (   6, 8110)
        write (   6, 8112)
        write (   6, 8114)
        call aptffip (5, fd, iamax, idmax, iemax, aword, iword, fword,
     &                mtype, lword, nword, achar, nerr)
        go to 102
      endif

      do 110 n = 1, 5
        if (aword(1) .eq. aend80) then  ! User wants to end run.
          stop 'user done'
        endif
  110 continue

c=======================================================================********

c.... See if the input file can be opened.  If not, ask for name again.

c.... Find name of input file.

      ainput  = aword(1)

      iin   = 2                       ! IOC for text input file.
      iopt  = -1

  120 isize = 0
      atype = 'text'

      call openx (iin, ainput, atype, iopt, isize)  ! IOC 2 ASCII input.

 8120 format ('  Input file ',a,
     &  ' can not be opened.  Type new name or "end".')
 8125 format (a)

      if (isize .eq. -1) then         ! File ainput can not be opened.

  130   write (   6, 8120) ainput
        read  (   5, 8125) ainput

        if (ainput .eq. ablank80) go to 130

        if (ainput .eq. aend80) then  ! User wants to end run.
          stop 'user done'
        endif

        go to 120

      endif

c=======================================================================********

c.... Find name of output file.

 8150 format ('  Type name of output file or "end".')

      if ((nword .le. 1) .or. (nword .gt. 2)) then
  160   write (   6, 8150)
        read  (   5, 8125) aoutput
        if (aoutput .eq. ablank80) go to 160
      elseif (nword .eq. 2) then
        aoutput = aword(2)
      endif

 8160 format ('  File ',a,' is input file.')

  165 if (aoutput .eq. ainput) then
        write (   6, 8160) aoutput
  170   write (   6, 8150)
        read  (   5, 8125) aoutput
        if (aoutput .eq. ablank80) go to 170
      endif

c.... Find output unit.

      iout = 3
      if (aoutput .eq. 'tty     ') then
        iout = 6
        go to 190
      endif

c.... See if output file can be opened.  If so, ask permission to write over.

      iopt = -1                       ! Open, or return isize = -1.
  180 isize = 100000

      call openx (iout, aoutput, 'hardcopy', iopt, isize)

 8180 format ('  File ',a,' already exists.  Type yes to write over.')

      if (iopt .eq. -1) then          ! See if file aoutput was opened.
        if (isize .eq. -1) then       ! File aoutput can not be opened.

          iopt = 0                    ! Create new file aoutput.
          go to 180

        else                          ! File aoutput was opened.

          write (   6, 8180) aoutput
          read  (   5, 8125) ans
          if ((ans .eq. 'yes') .or.
     &        (ans .eq. 'y'))  then
            rewind (iout)             ! Write over existing output file.
            go to 190
          endif

          call closey (iout, aoutput, 'hardcopy')

          write (   6, 8150)
          read  (   5, 8125) aoutput
          go to 165

        endif                         ! Tested isize.
      endif                           ! Tested iopt.

  190 continue

c=======================================================================********

c.... Write out the version and run time.

 8182 format ('  Run time is ',3(2x,a8))

      write (iout, 8100) aversion, loddate, lodtime, lodmach
      write (iout, 8182) adate, atime, amach

c.... Write out the input and output file names.

 8185 format ('  Input  file is ',a)
 8190 format ('  Output file is ',a)

      write (   6, 8185) ainput
      write (iout, 8185) ainput
      write (   6, 8190) aoutput
      write (iout, 8190) aoutput

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.')")

      asrce = "variable(subscript)"
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold 8777 format (/ 'MAIN' / 'asrce = ',a / 'astem = ',a / 'asubs = ', a)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  NO SUBSCRIPT.')")

      asrce = "variableXsubscript)"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  NO SUBSCRIPT.')")

      asrce = "variable(subscriptX"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  NO SUBSCRIPT.')")

      asrce = "variableXsubscriptX"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  NO STEM.')")

      asrce = "(variable(subscript)"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  NO STEM.')")

      asrce = "(subscript)"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Stem has leading blanks.')")

      asrce = "   variable(subscript)"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Stem has middle blanks.')")

      asrce = "vari   able(subscript)"

      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Stem ends with blanks.')")

      asrce = "variable   (subscript)"
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Subscript has blanks 1.')")

      asrce = "variable(   subscript)"
      call aptsubr (asrce, 1, 80, 80, astem,
     &              lstem, asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Subscript has mid blanks.')")

      asrce = "variable(subsc   ript))"
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Subscript has blanks 2.')")

      asrce = "variable((subscript   )"
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Subscript has blanks 3.')")

      asrce = "variable(subs()cript)   "
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  Lots of blanks.')")

      asrce = "   variable   (   subscript   )   "
      call aptsubr (asrce, 1, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  ERROR # 1.')")

      asrce = "variable(subscript)"

      call aptsubr (asrce, 0, 80, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  ERROR # 2.')")

      asrce = "variable(subscript)"

      call aptsubr (asrce, 1,  0, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  ERROR # 3.')")

      asrce = "variable(subscript)"

      call aptsubr (asrce, 1,  80, 0, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c.... TEST SECTION.

      write (iout, "(/ 80('='))")
      write (iout, "(/ 'TESTING APTSUBR.  ERROR # 4.')")

      asrce = "variable(subscript)"

      call aptsubr (asrce, 1,  90, 80, astem, lstem,
     &              asubs, lsubs, nerr)

cold      write (   6, 8777) asrce, astem, asubs
cold      write (iout, 8777) asrce, astem, asubs

c=======================================================================********

c     call aptsubr (asrce, 1, 80, 80, astem, lstem, asubs, lsubs, nerr)

c=======================================================================********

c.... End of TEST SECTION.

      call system (
     &  "date +""  Run date and time:  ""'%Y %b %d %T %a' >> junk.time")

      call system ('echo $cwd')

  999 stop 'All done'

c.... End of subroutine main.         (+ 1 line).
      end
